{
Not Just Another Fuc*ing Space Shooter


Copyright (c) 2006 Jan Jirkovsky
based upon code samples in Asphyre v1.1.0 [ PRO Edition ] by Yuriy Kotsarenko
see http://www.afterwarp.net/ for more info about Asphyre Component Pack

//---------------------------------------------------------------------------
// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you may not use this file except in
// compliance with the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
// License for the specific language governing rights and limitations
// under the License.
//---------------------------------------------------------------------------

}



{
---
AUDIO.PAS
Small audio manager - designed to play one music file :). However, I have used
it in three projects so far with only minor changes. It can be easily improved to
play more music types (those supported by FMOD), play sounds and offer more possibilities.
In this project I needed only simple music loop (with option to stop or pause it),
so I only made this small and very simple player.

Uses FMOD - http://www.fmod.org/
---
}

unit audio;

interface

type
     TMiniAudio = class
               private

               protected
               public
                    music : pointer;
                    playing: boolean;
                    channel : integer;
                    musicvolume: integer;
                    paused : boolean;
                    wasplaying: boolean;

                    constructor Create ();
                    destructor Destroy();  override;

                    procedure PlayMusic (filename: string);  // music in MOD format
                    procedure Restart ();
                    procedure Pause ();
                    procedure Continue ();
              end;


var AudioManager: TMiniAudio;


implementation
uses Fmod, FmodTypes;

//---------------------------------------------------------------------------

constructor TMiniAudio.Create ();
BEGIN

inherited Create();
playing := true;
wasplaying:= false;
musicvolume := 128;
FSOUND_Init(44100, 32, 0);

END;

//---------------------------------------------------------------------------

destructor TMiniAudio.Destroy ();
BEGIN

FMOD_Unload;
inherited Destroy();

END;


//---------------------------------------------------------------------------

procedure  TMiniAudio.PlayMusic (filename: string);
begin

music := FMUSIC_LoadSong(PAnsiChar('./audio/'+filename));
FMUSIC_PlaySong(music);
FMUSIC_SetMasterVolume(music,musicvolume);

end;



//---------------------------------------------------------------------------

procedure TMiniAudio.Restart ();
BEGIN

FMUSIC_PlaySong(music);
FMUSIC_SetPaused (music,not playing);

END;

//---------------------------------------------------------------------------

procedure TMiniAudio.Pause ();
BEGIN

playing := false;
FMUSIC_SetPaused (music,not playing);

END;

//---------------------------------------------------------------------------

procedure TMiniAudio.Continue ();
BEGIN

playing := true;
FMUSIC_SetPaused (music,not playing);


END;

//---------------------------------------------------------------------------


//end of audio.pas
end.

