{
Not Just Another Fuc*ing Space Shooter


Copyright (c) 2006 Jan Jirkovsky
based upon code samples in Asphyre v1.1.0 [ PRO Edition ] by Yuriy Kotsarenko
see http://www.afterwarp.net/ for more info about Asphyre Component Pack

//---------------------------------------------------------------------------
// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you may not use this file except in
// compliance with the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
// License for the specific language governing rights and limitations
// under the License.
//---------------------------------------------------------------------------

}





unit main;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Math,
  AsphyreKeyboard,
  AsphyreStates,
  AsphyreImages,
  AsphyreDevices,
  AsphyreCanvas,
  AsphyreComp,
  AsphyreTimers,
  AsphyreFonts,
  VTDb3,
  AsphyreDef,
  ExtCtrls,
  DirectInput,

  gameobjects,
  maploading,
  audio;


type
  TForm1 = class(TForm)
    Fonts: TAsphyreFonts;
    Timer: TAsphyreTimer;
    Device: TAsphyreDevice;
    Canvas: TAsphyreCanvas;
    Images: TAsphyreImages;
    DeviceState: TDeviceState;
    Keyboard: TAsphyreKeyboard;
    VTDb: TVTDb;
    Panel1: TPanel;
    Shape1: TShape;

    procedure AppActivate(Sender: TObject);
    procedure AppDeActivate(Sender: TObject);
    procedure AppActivateMIN(Sender: TObject);
    procedure AppDeActivateMIN(Sender: TObject);

    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DeviceInitDevice(Sender: TObject;
      var ExitCode: Integer);
    procedure TimerRender(Sender: TObject; FrameRate: Integer);
    procedure TimerProcess(Sender: TObject);
    procedure DeviceFinalize(Sender: TObject);

    procedure InputProcessGame;
    procedure InputProcessSystem;

    procedure IntroProcess;

    procedure Managers_Move();
    procedure Managers_Collide();
    procedure Managers_Update();



    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SetEndAll();
    procedure SetStartAll();
    procedure Restart();

  end;

var
  Form1: TForm1;
  p0,p: TPoint;
  xf,yf: integer;

  IntroEnemy1 : TEnemy1;
  IntroEnemy2 : TEnemy1;
  IntroEnemy3 : TEnemy1;


implementation

{$R *.dfm}




//---------------------------------------------------------------------------

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

 if (Key = VK_ESCAPE) then
 begin
     Close();
 end;

end;




//---------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
var
 Res: Integer;
begin
randomize();

Application.OnDeactivate := AppDeactivate;
Application.OnActivate := AppActivate;

Application.OnMinimize := AppDeactivateMIN;
Application.OnRestore := AppActivateMIN;

// redirect rendering to our panel
 Device.WindowHandle:= Panel1.Handle;


 Res:= Device.InitDevice();
 if (Res <> errNone) then
  begin
   MessageDlg(ErrorString(Res), mtError, [mbOk], 0);
   Close();
   Exit;
  end;


Cursor :=-1;
Panel1.Cursor := -1;
end;



//---------------------------------------------------------------------------





procedure TForm1.DeviceInitDevice(Sender: TObject;
  var ExitCode: Integer);
begin
  ExitCode := errNone;

 // fonts
 ExitCode:= Fonts.LoadFromVTDb(VTDb);

 // images
 if (ExitCode = errNone) then
  ExitCode:= Images.LoadFromVTDb(VTDb);


 Timer.MayRender:= (ExitCode = errNone);

 Keyboard.Initialize;
 DeviceState.Update;



GCanvas := Canvas;
GImages := Images;


AudioManager :=TMiniAudio.Create;
AudioManager.PlayMusic('pb_sacred.xm');
AudioManager.wasplaying := true;

minimalized := false;

//MakeCollisions := true;
//MakeMove := true;

SetStartAll();




end;








//---------------------------------------------------------------------------



procedure TForm1.TimerRender(Sender: TObject; FrameRate: Integer);
var Res: integer;   i: integer;
begin

 Device.Clear($FF000000);
 Res:= Device.BeginScene();
 if (Res <> errNone) then Exit;

 with Canvas do
  begin

       //draw background consisting of 4 patterns (150*110 patterns -> 300*220 screen)
       Draw(Images.Image['background'],0,0,0,doxDraw);
       Draw(Images.Image['background'],150,0,1,doxDraw);
       Draw(Images.Image['background'],0,110,2,doxDraw);
       Draw(Images.Image['background'],150,110,3,doxDraw);

       //if game is running, draw life meter ("$" sign), darkened part is based upon life count  (more damaged you are, bigger part is darkened)
       if ((not victory) and (not defeat) and (introcompleted)) then
          begin
               Draw(GImages.Image['life'],5,190,0,doxDraw);
               Rectangle(5,195,16,21-round((PlayerShip.life /10)*21),$00000000,$FF000000,doxDraw);
               Diffuse(GImages.Image['life'],5,190,$60FFFFFF,0,doxDiffuse);
          end;

end;


          //here we render all objects
          ManagerEnemyShips.Render(nil);      //render enemy ships
          ManagerBulletsFriendly.Render(nil); // render friendly bullets  AND player's ship
          ManagerBulletsEnemy.Render(nil);    // render enemy bullets
          FragmentManager.Render(nil);        //render particles - ship and bullet fragments etc.

  if defeat then
                begin
                    Canvas.Diffuse(Images.Image['background'],0,0,$FFFFFF or (min(DefeatTime ,255) shl 24),0,doxDiffuse);
                    Canvas.Diffuse(Images.Image['background'],150,0,$FFFFFF or (min(DefeatTime ,255) shl 24),1,doxDiffuse);
                    Canvas.Diffuse(Images.Image['background'],0,110,$FFFFFF or (min(DefeatTime ,255) shl 24),2,doxDiffuse);
                    Canvas.Diffuse(Images.Image['background'],150,110,$FFFFFF or (min(DefeatTime ,255) shl 24),3,doxDiffuse);
                end;


 if introcompleted = false
     then
          BEGIN
                       if PassedTime < 256 then
                        Canvas.Diffuse(Images.Image['logo'],80,45,$FFFFFF or (min(PassedTime,255) shl 24),0,doxDiffuse);

                      if (PassedTime >= 256) and (PassedTime < 512) then
                        Canvas.Diffuse(Images.Image['logo'],80,45,$FFFFFF or ($FF000000-min(PassedTime -255,255) shl 24),0,doxDiffuse);


                      if (PassedTime >= 512) and (PassedTime < 756) then
                      begin
                        Fonts[0].TextOut('The soldiers involved in', 40, 70,$FFFFFF or (min(PassedTime-512,255) shl 24));
                        Fonts[0].TextOut('Cold war were fighting in more', 20, 90,$FFFFFF or (min(PassedTime-512,255) shl 24));
                        Fonts[0].TextOut('front lines than you may think!', 20, 110,$FFFFFF or (min(PassedTime-512,255) shl 24));
                      end;

                      if (PassedTime >= 756) and (PassedTime < 1024) then
                      begin
                        Fonts[0].TextOut('The soldiers involved in', 40, 70,$FFFFFFFF);
                        Fonts[0].TextOut('Cold war were fighting in more', 20, 90,$FFFFFFFF);
                        Fonts[0].TextOut('front lines than you may think!', 20, 110,$FFFFFFFF);
                      end;

                       if (PassedTime >= 1024) and (PassedTime < 1024+256) then
                      begin
                        Fonts[0].TextOut('The soldiers involved in', 40, 70,$FFFFFF or ($FF000000-min(PassedTime-1024,255) shl 24));
                        Fonts[0].TextOut('Cold war were fighting in more', 20, 90,$FFFFFF or ($FF000000-min(PassedTime-1024,255) shl 24));
                        Fonts[0].TextOut('front lines than you may think!', 20, 110,$FFFFFF or ($FF000000-min(PassedTime-1024,255) shl 24));
                      end;



                        for i:= 0 to 5 do
                       Canvas.Diffuse(Images.Image['intro'],0+i*50,min((PassedTime div 3)-200,0-max(IntroLength-32,PassedTime)+IntroLength-32),$FFFFFFFF,i,doxDiffuse);

                        for i:= 0 to 5 do
                         Canvas.Diffuse(Images.Image['intro'],0+i*50,max(ysize-(PassedTime div 3)+200-25,ysize-25+max(IntroLength-32,PassedTime)-IntroLength+32),$FFFFFFFF,i+6,doxDiffuse);

                        if passedtime>600 then
                         begin
                              Canvas.Draw(Images.Image['rec'],255,8,0,doxDraw);
                              if passedtime mod 120 <60 then Canvas.Rectangle(255,8,10,10,$0,$FF000000,doxDraw);
                         end;




         END;

       if paused then
       Fonts[0].TextOut('PAUSED', 120, 100,$FFFFFFFF);

 if victory then
                    begin

                    if victorytime < 256                              then Fonts[0].TextOut('Score: ' + IntToStr(Score), 113, 20, $FFFFFF or (min(victorytime,255) shl 24));
                    if (victorytime >= 256) and (victorytime < 512)   then Fonts[0].TextOut('Score: ' + IntToStr(Score), 113, 20, $FFFFFF or ($FF000000-min(victorytime -255,255) shl 24));


                      if victorytime < 256 then
                        Canvas.Diffuse(Images.Image['logo'],80,45,$FFFFFF or (min(victorytime,255) shl 24),0,doxDiffuse);

                      if (victorytime >= 256) and (victorytime < 512) then
                        Canvas.Diffuse(Images.Image['logo'],80,45,$FFFFFF or ($FF000000-min(victorytime -255,255) shl 24),0,doxDiffuse);




                      if (victorytime >= 512) and (victorytime < 756) then
                        Fonts[0].TextOut('Thanks for playing!', 70, 103,$FFFFFF or (min(victorytime-512,255) shl 24));

                      if (victorytime >= 756) and (victorytime < 1024) then
                        Fonts[0].TextOut('Thanks for playing!', 70, 103,$FFFFFF or ($FF000000-min(victorytime-756,255) shl 24));




                    Fonts[0].TextOut('Design & Graphics', 81,                    450-victorytime div 3, $FFFFFFFF);
                    Fonts[0].TextOut('Peter "Kahi" Kahoun', 70,    480-victorytime div 3, $FFFFFFFF);

                    Fonts[0].TextOut('Programming', 98,           120+450-victorytime div 3, $FFFFFFFF);
                    Fonts[0].TextOut('Jan "Sysel/Sosol" Jirkovsky', 32,         120+480-victorytime div 3, $FFFFFFFF);

                    Fonts[0].TextOut('Music', 127,                       240+450-victorytime div 3, $FFFFFFFF);
                    Fonts[0].TextOut('Stepan "Mr. Stewe" Voles', 42,     240+480-victorytime div 3, $FFFFFFFF);



                     if victorytime > (2048-256) then
                        Fonts[0].TextOut('The End', 121, 103,$FFFFFF or (min(victorytime-(2048-256),255) shl 24));

                    end;


 if defeat then Fonts[0].TextOut ('You were defeated!', 70, 95, $FFFFFFFF);
 if defeat then Fonts[0].TextOut ('Press "R" to restart game', 40, 120, $FFFFFFFF);
 if defeat then Fonts[0].TextOut('Score: ' + IntToStr(Score), 113, 20, $FFFFFFFF);




 // if FPS info turned on, write actual framerate on screen
 if showFPS then Fonts[0].TextOut('FPS: ' + IntToStr(FrameRate), 4, 3, $FFFFFFFF);




 // debug
// if ShowPosition then Fonts[0].TextOut('X: ' + IntToStr(-1950-Introlength-movedbyX{+round(PlayerShip.Position.x)}+PassedTime), 100, 3, $FFFFFFFF);

 Canvas.Flush();
 Device.EndScene();
 Timer.Process(1.0);
 Device.Present();
end;







//---------------------------------------------------------------------------


procedure TForm1.TimerProcess(Sender: TObject);
begin

     KeyBoard.Update;

     if (not lostfocus) then
          BEGIN

               InputProcessSystem;
               if (defeat = false) and (introcompleted=true) then InputProcessGame;
               if defeat then inc(defeattime);
               if victory then inc(victorytime);

               if PassedTime>IntroLength then introcompleted := true;

               if (paused=false) then
                    begin
                       if MakeMove then  inc(PassedTime);
                       if MakeMove then  Managers_Move();
                       if MakeCollisions then  Managers_Collide();
                         Managers_Update();
                         FragmentManager.Update;
                    end;


               if introcompleted = false then IntroProcess;


          END;
   
end;








//---------------------------------------------------------------------------



{ UGLY CODING!!!! This part consist mainly of pre-scripted actions,
 which (to be honest) shouldn't be directly in source code.
 It would be better to load these "actions" from "outside", for example
 from some text or XML based datafile. But this game was destined to be small
 and easily coded, co I didn't care about loading and I typed it directly here.
 When writing some larger games, ALL data alike should be stored in external files.

 And yes, I know, whole intro is written in a bad way... you should teach a lesson
 from these sources. Do not do it this way, at least if you plan to write a larger
 game project!

 It was hard to synchronize the timing of the actions and it took a lot of re-writing.
 This is my past, next time I hope I'll do better! ;)
  }

procedure TForm1.IntroProcess();
begin


          if playership.Position.x<30 then playership.Position.x := playership.Position.x+0.5;


               if (passedtime = 950+500)
               or (passedtime = 1210+650)
               or (passedtime = 1240+650)
               or (passedtime = 1285+650)
                    then
               playership.Shoot1;


           if (passedtime = 1210+650)
              then
                    begin
                        IntroEnemy3.Shoot;
                    end;




          if ((passedtime >(950+650)) and (passedtime <=(1000+650))) then
               begin
                    IntroEnemy1.Velocity.x := IntroEnemy1.Velocity.x+0.02;
                    IntroEnemy2.Velocity.x := IntroEnemy2.Velocity.x+0.02;
                    IntroEnemy1.PathType := 0;
                    IntroEnemy2.PathType := 0;
               end;



          if ((passedtime >(1000+650)) and (passedtime <=(1040+650)))  then
               begin
                    IntroEnemy1.Velocity.x := 0;
                    IntroEnemy2.Velocity.x := 0;
               end;


            if ((passedtime >(1040+650)) and (passedtime <=(1400+650))) then
               begin
                    IntroEnemy1.Velocity.x := IntroEnemy1.Velocity.x+0.02;
                    IntroEnemy2.Velocity.x := IntroEnemy2.Velocity.x+0.02;
               end;



           if (passedtime >(1200+650)) then
               begin
                    IntroEnemy1.Velocity.x := -2;
                    IntroEnemy2.Velocity.x := -2;
                    IntroEnemy3.Velocity.x := -2;
                    IntroEnemy3.Position.x := IntroEnemy2.Position.x-20;
               end;



          if passedtime > 250+1600 then
               begin
               playership.Velocity.y := playership.Velocity.y -0.1;
               end;
          if passedtime > 280+1600 then
               begin
               playership.Velocity.y := playership.Velocity.y +0.2;
               end;

          if passedtime > 340+1600 then
               begin
               playership.Velocity.y := playership.Velocity.y -0.3;
               end;

         if passedtime > 360+1600 then
               begin
               playership.Velocity.y := playership.Velocity.y+0.35;
               end;

         if passedtime > 380+1600 then
               begin
               playership.Velocity.y :=0;
               end;


end;








//---------------------------------------------------------------------------

procedure TForm1.InputProcessGame();
begin

if (Keyboard.Key [DIK_LEFT]) or (Keyboard.Key [DIK_A]) then
  begin
  if not(PlayerShip.Velocity.X <(-PlayerShip.speed)) then
    begin
    PlayerShip.Velocity := Point2(PlayerShip.Velocity.X-PlayerShip.accel,PlayerShip.Velocity.Y);
    if PlayerShip.Velocity.X < (-PlayerShip.speed) then PlayerShip.Velocity  := point2((-PlayerShip.speed),PlayerShip.Velocity.y);
    end;
  end;





if (Keyboard.Key [DIK_right]) or (Keyboard.Key [DIK_D]) then
    begin
   if not(PlayerShip.Velocity.X >PlayerShip.speed) then
        begin
        PlayerShip.Velocity := point2(PlayerShip.Velocity.X+PlayerShip.accel,PlayerShip.Velocity.Y);
        if PlayerShip.Velocity.X > PlayerShip.speed then PlayerShip.Velocity  := point2((PlayerShip.speed),PlayerShip.Velocity.y);
        end;
    end;





if (Keyboard.Key [DIK_UP]) or (Keyboard.Key [DIK_W]) then
  begin
  if not(PlayerShip.Velocity.Y <(-PlayerShip.speed)) then
    begin
    PlayerShip.Velocity := point2(PlayerShip.Velocity.X,PlayerShip.Velocity.Y-PlayerShip.accel);
    if PlayerShip.Velocity.Y < (-PlayerShip.speed) then PlayerShip.Velocity  := point2(PlayerShip.Velocity.x,(-PlayerShip.speed));
    end;
  end;







if (Keyboard.Key [DIK_DOWN]) or (Keyboard.Key [DIK_S]) then
  begin
  if not(PlayerShip.Velocity.Y >PlayerShip.speed) then
    begin
    PlayerShip.Velocity := point2(PlayerShip.Velocity.X,PlayerShip.Velocity.Y+PlayerShip.accel);
    if PlayerShip.Velocity.Y > PlayerShip.speed then PlayerShip.Velocity  := point2(PlayerShip.Velocity.x,PlayerShip.speed);
    end;




  end;


if (Keyboard.KeyPressed [DIK_LCONTROL]) or (Keyboard.KeyPressed [DIK_SPACE]) or (Keyboard.KeyPressed [DIK_RSHIFT]) or (Keyboard.KeyPressed [DIK_LSHIFT])
     then PlayerShip.Shoot1;


if (Keyboard.Key [DIK_LCONTROL]) or (Keyboard.Key [DIK_SPACE]) or (Keyboard.Key [DIK_RSHIFT]) or (Keyboard.Key [DIK_LSHIFT])
     then PlayerShip.Shoot2;

end;











//---------------------------------------------------------------------------

procedure TForm1.InputProcessSystem();
begin

if Keyboard.Keypressed [DIK_F5] then begin
ShowFPS := not ShowFPS;
end;




 // CHEATS + debug etc.

      {
if Keyboard.Keypressed [DIK_F6] then begin
ShowCollide := not ShowCollide;
end;


if Keyboard.Keypressed [DIK_F4] then begin
ShowPosition := not ShowPosition;
end;




if Keyboard.Keypressed [DIK_F3] then begin
Playership.Life := 10000;
end;

if Keyboard.Keypressed [DIK_F9] then begin
    ManagerEnemyShips.MoveALLbyX (1000);
end;

if Keyboard.Keypressed [DIK_F10] then begin
    ManagerEnemyShips.MoveALLbyX (100);
end;

if Keyboard.Keypressed [DIK_F11] then begin
    ManagerEnemyShips.MoveALLbyX (-100);
end;

if Keyboard.Keypressed [DIK_F12] then begin
    ManagerEnemyShips.MoveALLbyX (-1000);
end;

if Keyboard.Keypressed [DIK_F1] then begin
    MakeCollisions := not MakeCollisions;
end;

if Keyboard.Keypressed [DIK_F2] then begin
    MakeMove := not MakeMove;
end;


if Keyboard.Key [DIK_NUMPAD3] then begin
    ManagerEnemyShips.MoveALLbyX (-3);
end;

if Keyboard.Key [DIK_NUMPAD1] then begin
    ManagerEnemyShips.MoveALLbyX (3);
end;


if Keyboard.Key [DIK_NUMPAD6] then begin
    ManagerEnemyShips.MoveALLbyX (-8);
end;

if Keyboard.Key [DIK_NUMPAD4] then begin
    ManagerEnemyShips.MoveALLbyX (8);
end;



if Keyboard.Key [DIK_NUMPAD9] then begin
    ManagerEnemyShips.MoveALLbyX (-15);
end;

if Keyboard.Key [DIK_NUMPAD7] then begin
    ManagerEnemyShips.MoveALLbyX (15);
end;


}


if Keyboard.Keypressed [DIK_M] then begin
if audiomanager.playing then
     begin
          Audiomanager.Pause;
          AudioManager.wasplaying := false;
     end
          else
     begin
          Audiomanager.Continue;
          Audiomanager.wasplaying := true;
     end;
end;

if IntroCompleted then if (Keyboard.Keypressed [DIK_P]) or ((Keyboard.Keypressed [DIK_Pause])) then
     begin
          Paused := not Paused;
          pausedtime:= 0;
     end;

if Keyboard.Keypressed [DIK_NUMPADMINUS] then begin
if Timer.Speed >= 10 then Timer.Speed := Timer.Speed - 10;
end;


if Keyboard.Keypressed [DIK_NUMPADPLUS] then begin
Timer.Speed := Timer.Speed + 20;
end;

if Keyboard.Keypressed [DIK_NUMPADENTER ] then begin
Timer.Speed := 60;
end;

if Keyboard.Keypressed [DIK_R] then begin
Restart();
AudioManager.Restart;
end;

 if ((Keyboard.Keypressed [DIK_SPACE]) or (Keyboard.Keypressed [DIK_RETURN])) and (passedtime<IntroLength) then
     begin

     IntroEnemy1.Dying := true;
     IntroEnemy2.Dying := true;
     IntroEnemy3.Dying := true;
     PlayerShip.Position.x := 30;
     PlayerShip.Position.y := 100;
     introcompleted := true;

     ManagerEnemyShips.MoveALLbyX (-(IntroLength-passedtime));

     passedtime := IntroLength;
     end;





end;














//---------------------------------------------------------------------------

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Device.Finalize();
end;



//---------------------------------------------------------------------------

procedure TForm1.DeviceFinalize(Sender: TObject);
begin
 Images.RemoveAll();
 Fonts.RemoveAll();
 Keyboard.Finalize;
 AudioManager.Destroy;
 SetEndAll();

 Timer.MayRender:= False;
end;


//---------------------------------------------------------------------------

procedure TForm1.Managers_Move();
begin
ManagerBulletsFriendly.Move;
ManagerBulletsEnemy.Move;
ManagerEnemyShips.Move;
end;

//---------------------------------------------------------------------------

procedure TForm1.Managers_Collide();
begin


if defeat = false then ManagerBulletsEnemy.DoCollide (PlayerShip);
ManagerBulletsFriendly.CollideWithManager(ManagerEnemyShips);

end;

//---------------------------------------------------------------------------

procedure TForm1.Managers_Update();
begin
ManagerBulletsFriendly.Update;
ManagerBulletsEnemy.Update;
ManagerEnemyShips.Update;
end;

//---------------------------------------------------------------------------




procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     GetCursorPos(p0);

     xf := p0.x - Form1.Left;
     yf := p0.y - Form1. Top;
end;


//---------------------------------------------------------------------------


procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     GetCursorPos(p);

     Form1.Left := p.x - xf;
     Form1.Top := p.y - yf;
end;

//---------------------------------------------------------------------------


procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     GetCursorPos(p0);

     xf := p0.x - Form1.Left;
     yf := p0.y - Form1. Top;
end;


//---------------------------------------------------------------------------

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     GetCursorPos(p);

     Form1.Left := p.x - xf;
     Form1.Top := p.y - yf;
end;

//---------------------------------------------------------------------------

procedure TForm1.AppActivate(Sender: TObject);
begin
     if not minimalized then
          BEGIN
               if AudioManager.wasplaying then AudioManager.Continue;

               LostFocus:= false;
          END;
end;


//---------------------------------------------------------------------------


procedure TForm1.AppDeactivate(Sender: TObject);
begin
     if not minimalized then
         BEGIN
               AudioManager.Pause;
               LostFocus:= true;
         END;
end;

//---------------------------------------------------------------------------

procedure TForm1.AppActivateMIN(Sender: TObject);
begin
     minimalized := false;

     if Audiomanager.wasplaying then Audiomanager.Continue;

     LostFocus:= false;
end;

//---------------------------------------------------------------------------

procedure TForm1.AppDeactivateMIN(Sender: TObject);
begin
     minimalized := true;
     AudioManager.Pause;
     LostFocus:= true;
end;

//---------------------------------------------------------------------------


procedure TForm1.SetStartAll();
begin


    ShowCollide:= false;
    ShowFPS:= false;





    score:= 0;
    victory :=false;
    victorytime:=0;
    defeat :=false;
    defeattime:=0;

    bossready :=false;
    passedtime:=0;
    introcompleted:=false;

    paused:=false;
    pausedtime:=0;
    LostFocus:=false;

    minimalized:=false;


    MakeCollisions:=true;
    MakeMove:=true;
    ShowPosition:=false;
    MovedByX:=0;





ManagerBulletsFriendly := TObjectManager.Create ();
ManagerBulletsEnemy := TObjectManager.Create ();
ManagerEnemyShips := TObjectManager.Create ();

FragmentManager := TFragmentManager.Create;

PlayerShip := TPlayerShip.Create(ManagerBulletsFriendly,point2(-660,90));


     IntroEnemy1 := TEnemy1.Create(ManagerEnemyShips ,point2(1870,70));
     IntroEnemy1.PathType := 1;
     IntroEnemy1.PathAux1 := 0;
     IntroEnemy1.PathAux2 := 0;
     IntroEnemy1.ReloadTime := 5000;
     IntroEnemy1.RowReloadTime := 5000;
     IntroEnemy1.MaxSpeed := point2(1,1);
     IntroEnemy1.MaxAccel := point2(0.04,0.04);



     IntroEnemy2 := TEnemy1.Create(ManagerEnemyShips ,point2(1870,110));
     IntroEnemy2.PathType := 1;
     IntroEnemy2.PathAux1 := 0;
     IntroEnemy2.PathAux2 := 0;
     IntroEnemy2.ReloadTime := 5000;
     IntroEnemy2.RowReloadTime := 5000;
     IntroEnemy2.MaxSpeed := point2(1,1);
     IntroEnemy2.MaxAccel := point2(0.04,0.04);


     IntroEnemy3 := TEnemy1.Create(ManagerEnemyShips ,point2(5100,90));
     IntroEnemy3.PathType := 1;
     IntroEnemy3.PathAux1 := 0;
     IntroEnemy3.PathAux2 := 0;
     IntroEnemy3.ReloadTime := 5000;
     IntroEnemy3.RowReloadTime := 5000;
     IntroEnemy3.MaxSpeed := point2(1,1);
     IntroEnemy3.MaxAccel := point2(0.04,0.04);


LoadMap;
end;


procedure TForm1.SetEndAll();
begin
ManagerBulletsFriendly.Destroy ();
ManagerBulletsEnemy.Destroy ();
ManagerEnemyShips.Destroy ();
FragmentManager.Destroy ();
end;

procedure TForm1.Restart();
begin
SetEndAll();
SetStartAll();
end;

//---------------------------------------------------------------------------
//this is the end of main.pas
end.
