{
Not Just Another Fuc*ing Space Shooter


Copyright (c) 2006 Jan Jirkovsky
based upon code samples in Asphyre v1.1.0 [ PRO Edition ] by Yuriy Kotsarenko
see http://www.afterwarp.net/ for more info about Asphyre Component Pack

//---------------------------------------------------------------------------
// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you may not use this file except in
// compliance with the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
// License for the specific language governing rights and limitations
// under the License.
//---------------------------------------------------------------------------

}




{
---
MAPLOADING.PAS
Loading of objects on map from mapfile - quite easy "map language", simple management.
Objects on map are qualified as types of TEnemyShip (TEnemy1...4, TBoss).
It is designed to be more less "stand-alone"  (means that main program calls
only one procedure to process entire map and put enemies to their managers - LoadMap(); )
---
}

unit maploading;

interface

procedure LoadMap; //LoadMap is the only externally called procedure in this unit




implementation

uses SysUtils,AsphyreDef,gameobjects;

const mapfilename='map.txt'; //defined filename with map data
      digits = ['0','1','2','3','4','5','6','7','8','9'];  // ehh, just set of digits :-)




//---------------------------------------------------------------------------

function LinePartProcess(line:string; var actpos:integer) : integer;
var i: integer; number : string;
begin

i := actpos;

while (i<length(line)) and (not (line [i] in digits))  do inc(i);

while ((line [i] in digits)) do
     begin
          number := number + line [i];
          inc(i);
     end;

actpos := i;
result := strtoint(number);
end;

//---------------------------------------------------------------------------

procedure MapLineProcess(line:string);
var X,Y,EnemyType,PathType,PathAux1,PathAux2,Speed,ShootSpeed : integer;
     actpos: integer;
     Enemy: TEnemyShip;

begin
actpos := 1;

x          :=  LinePartProcess (line,actpos)+IntroLength;
y          :=  LinePartProcess (line,actpos);
EnemyType  :=  LinePartProcess (line,actpos);
PathType   :=  LinePartProcess (line,actpos);
PathAux1   :=  LinePartProcess (line,actpos);
PathAux2   :=  LinePartProcess (line,actpos);
Speed      :=  LinePartProcess (line,actpos);
ShootSpeed :=  LinePartProcess (line,actpos);

if EnemyType=1 then
     begin
     Enemy := TEnemy1.Create(ManagerEnemyShips ,point2(x,y));
     Enemy.PathType := PathType;
     Enemy.PathAux1 := PathAux1;
     Enemy.PathAux2 := PathAux2;

     Enemy.MaxSpeed := point2(Speed/100,Speed/100);
     Enemy.MaxAccel := point2(Speed/100/12,Speed/100/12);

     Enemy.RowReloadTime := ShootSpeed;

     if PathType=pathSinusoid then
          begin
               Enemy.MaxAccel.y := PathAux2/1000;
               Enemy.pathaux2 := round(y);

          end;
     end;

if EnemyType=2 then
      begin
     Enemy := TEnemy2.Create(ManagerEnemyShips ,point2(x,y));
     Enemy.PathType := PathType;
     Enemy.PathAux1 := PathAux1;
     Enemy.PathAux2 := PathAux2;

     Enemy.MaxSpeed := point2(Speed/100,Speed/100);
     Enemy.MaxAccel := point2(Speed/100/18,Speed/100/18);

     Enemy.RowReloadTime := ShootSpeed;

     if PathType=pathSinusoid then
          begin
               Enemy.MaxAccel.y := PathAux2/1000;
               Enemy.pathaux2 := round(y);
          end;
     end;


if EnemyType=3 then
      begin
     Enemy := TEnemy3.Create(ManagerEnemyShips ,point2(x,y));
     Enemy.PathType := PathType;
     Enemy.PathAux1 := PathAux1;
     Enemy.PathAux2 := PathAux2;

     Enemy.MaxSpeed := point2(Speed/100,Speed/100);
     Enemy.MaxAccel := point2(Speed/100/15,Speed/100/15);

     Enemy.RowReloadTime := ShootSpeed;

     if PathType=pathSinusoid then
          begin
               Enemy.MaxAccel.y := PathAux2/1000;
               Enemy.pathaux2 := round(y);
          end;
     end;



if EnemyType=4 then
      begin
     Enemy := TEnemy4.Create(ManagerEnemyShips ,point2(x,y));
     Enemy.PathType := PathType;
     Enemy.PathAux1 := PathAux1;
     Enemy.PathAux2 := PathAux2;

     Enemy.MaxSpeed := point2(Speed/100,Speed/100);
     Enemy.MaxAccel := point2(Speed/100/15,Speed/100/15);

     Enemy.RowReloadTime := ShootSpeed;

     if PathType=pathSinusoid then
          begin
               Enemy.MaxAccel.y := PathAux2/1000;
               Enemy.pathaux2 := round(y);
          end;
     end;


     
if EnemyType=9 then
      begin
          Boss := TBoss.Create(ManagerEnemyShips ,point2(x,y));
     end;

end;

//---------------------------------------------------------------------------

procedure LoadMap;
var f: TextFile; line: string;
begin
     AssignFile(f,mapfilename);
     Reset(F);

     while not eof(f) do
          begin
               Readln(F, line);
               Trim(line);
               if length(line)>0 then if line[1] in digits then MapLineProcess (line);
          end;

     CloseFile(F);
end;

//---------------------------------------------------------------------------



//end of maploading.pas
end.
